#!/usr/bin/perl

use warnings;
use strict;
use Time::HiRes qw(gettimeofday tv_interval);

my $exec_file = $ARGV[0];
my $i;
if (index($exec_file,'/')!=0){
	$exec_file = './' . $exec_file;
}

for( $i=1; $i<=8; $i++){
	my $input_file = "input" . $i . ".txt";
	my $output_file = "output" . $i . ".txt";
	my $output_expect = `cat $output_file`;
	my $start = [gettimeofday];
	my $output_prog = `$exec_file < $input_file`;
	my $end = [gettimeofday];
	my $result = '';
	if ($output_expect eq $output_prog){
		$result = 'OK';
	} else {
		$result = 'NG';
	}
	printf "$input_file result=$result %.6f\n", tv_interval $start, $end;
}
